unit ucadCliente;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, Mask, uLocalizaReg;

type
  TfrmCadClientes = class(TForm)
    Panel4: TPanel;
    btnNovo: TBitBtn;
    btnSalvar: TBitBtn;
    btnCancelar: TBitBtn;
    btnApagar: TBitBtn;
    Panel1: TPanel;
    btnFechar: TBitBtn;
    btnProcura: TBitBtn;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    edCodigo: TEdit;
    cbTipo: TComboBox;
    edCPF_CNPJ: TMaskEdit;
    edNome: TEdit;
    edDatNasc: TMaskEdit;
    cbCexo: TComboBox;
    edObs: TEdit;
    cbAtivo: TCheckBox;
    ELookCliente: TLookFox;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnFecharClick(Sender: TObject);
    procedure btnProcuraClick(Sender: TObject);
    procedure btnNovoClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnSalvarClick(Sender: TObject);
    procedure btnCancelarClick(Sender: TObject);
    procedure btnApagarClick(Sender: TObject);
  private
    { Private declarations }
    //gNovo:boolean;
    procedure LimpaCampos;
    procedure ExcluirArquivo(prErro:boolean); 
    procedure AtualizaDadoNovo(prErro:boolean);
    procedure AtualizaDadoAltera(prErro:boolean);
    procedure enabledBotao(prNovo,prSalva,prCancela,prApaga,prProcura: boolean);
  public
    { Public declarations }
  end;

var
  frmCadClientes: TfrmCadClientes;

implementation

{$R *.dfm}

USES UDMDADOS, uCollectionFox, Math;


procedure TfrmCadClientes.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  action := Cafree;
  frmCadClientes := nil;
end;

procedure TfrmCadClientes.btnFecharClick(Sender: TObject);
begin
  close;
end;

procedure TfrmCadClientes.btnProcuraClick(Sender: TObject);
begin
  ELookCliente.Execute;
  if ELookCliente.gAlterou then
  begin
    edCodigo.text := inttostr(ELookCliente.FieldByName('I_COD_CLI').AsInteger);
    if ELookCliente.FieldByName('c_tip_cli').AsString = 'F' then
    begin
      cbTipo.ItemIndex := 0;
      edCPF_CNPJ.EditMask := '999.999.999/99;0;_'
    end
    else
    begin
      cbTipo.ItemIndex := 1;
      edCPF_CNPJ.EditMask := '99.999.999/9999-99;0;_'
    end;
    edCPF_CNPJ.text := ELookCliente.FieldByName('C_CPF_CNPJ').AsString;
    edNome.text := ELookCliente.FieldByName('C_NOM_CLI').AsString;
    edDatNasc.text := ELookCliente.FieldByName('D_NASC').AsString;
    if ELookCliente.FieldByName('c_sexo').AsString = 'M' then
      cbCexo.ItemIndex := 0
    else
      cbCexo.ItemIndex := 1;
    edObs.text := ELookCliente.FieldByName('OBS').AsString;
    cbAtivo.Checked := ELookCliente.FieldByName('c_ativo').AsString = 'Y';
    PageControl1.Enabled := true;
    enabledBotao(FALSE,FALSE,TRUE,TRUE,FALSE);    
  end;
end;

procedure TfrmCadClientes.btnNovoClick(Sender: TObject);
begin
  PageControl1.Enabled := true;
  LimpaCampos;
  //gNovo := true;
  enabledBotao(FALSE,TRUE,TRUE,FALSE,FALSE);
end;

procedure TfrmCadClientes.LimpaCampos;
var
  wind:Smallint;
begin
  for wind := 0 to componentcount - 1 do
  begin
    if components[wind] is TEdit then
      (components[wind] as TEdit).Text := ''
    else
    if components[wind] is TComboBox then
      (components[wind] as TComboBox).Text := ''
    else
    if components[wind] is TMaskEdit then
      (components[wind] as TMaskEdit).Text := '';
  end;
  cbAtivo.Checked := false;
  //gNovo := false;
end;

procedure TfrmCadClientes.AtualizaDadoNovo(prErro:boolean);
function BuscaCodigo:integer;
begin
  dmDados.qrBusca2.Close;
  dmDados.qrBusca2.SQL.Clear;
  dmDados.qrBusca2.sql.add('SELECT GEN_ID(Gen_i_cod_cli, 1) as ID from rdb$database');
  dmDados.qrBusca2.open;
  result := dmDados.qrBusca2.fieldbyname('ID').asinteger;
end;
var
  wmsg:string;
  wcodigo:integer;
begin
  try
    if not dmDados.ibTransDados.InTransaction then
       dmDados.ibTransDados.StartTransaction;
    dmDados.ibAtualizacao.Close;
    dmDados.ibAtualizacao.SQL.Add('INSERT INTO TCLIENTES(             ');
    dmDados.ibAtualizacao.SQL.Add('I_COD_CLI,C_NOM_CLI,C_CPF_CNPJ,    ');
    dmDados.ibAtualizacao.SQL.Add('C_SEXO,D_NASC,OBS,C_TIP_CLI,C_ATIVO)');
    dmDados.ibAtualizacao.SQL.Add('VALUES (:COD_CLI,:NOM_CLI,:CPF_CNPJ,    ');
    dmDados.ibAtualizacao.SQL.Add(':SEXO,:NASC,:OBS,:TIP_CLI,:ATIVO)');
    wCodigo := BuscaCodigo;
    dmDados.ibAtualizacao.ParamByName('COD_CLI').asinteger := wCodigo;
    edCodigo.text := inttostr(wCodigo);
    dmDados.ibAtualizacao.ParamByName('NOM_CLI').asstring  := edNome.text;
    dmDados.ibAtualizacao.ParamByName('CPF_CNPJ').asstring := edCPF_CNPJ.Text;
    if cbCexo.ItemIndex = 0 then
      dmDados.ibAtualizacao.ParamByName('SEXO').value      := 'M'
    else
      dmDados.ibAtualizacao.ParamByName('SEXO').value      := 'F';
    dmDados.ibAtualizacao.ParamByName('NASC').value        := strtodate(edDatNasc.text);
    dmDados.ibAtualizacao.ParamByName('OBS').value         := edObs.Text;
    if cbAtivo.Checked then
      dmDados.ibAtualizacao.ParamByName('ATIVO').value     := 'Y'
    else
      dmDados.ibAtualizacao.ParamByName('ATIVO').value     := 'N';
    if not dmDados.ibAtualizacao.Prepared then
      dmDados.ibAtualizacao.Prepare;
    dmDados.ibAtualizacao.execSQL;
    dmDados.ibTransDados.Commit;
  except
    ON E :EXCEPTION DO
    begin
      prErro := true;
      wmsg := 'Ocorreu o erro ' + e.Message;
      if dmDados.ibTransDados.InTransaction then
         dmDados.ibTransDados.Rollback;
      application.MessageBox(pchar(wmsg),'Ateno',0);
    end;     
  end;
end;

procedure TfrmCadClientes.FormCreate(Sender: TObject);
begin
  //gNovo := false;
end;

procedure TfrmCadClientes.AtualizaDadoAltera(prErro:boolean);
var
  wmsg :string;
begin
  try
    if not dmDados.ibTransDados.InTransaction then
       dmDados.ibTransDados.StartTransaction;
    dmDados.ibAtualizacao.Close;
    dmDados.ibAtualizacao.SQL.Add('UPDATE TCLIENTES SET                        ');
    dmDados.ibAtualizacao.SQL.Add('C_NOM_CLI = :NOM_CLI,C_CPF_CNPJ = :CPF_CNPJ,');
    dmDados.ibAtualizacao.SQL.Add('C_SEXO = :SEXO,D_NASC = :NASC,OBS = :OBS,  ');
    dmDados.ibAtualizacao.SQL.Add('C_TIP_CLI = :TIP_CLI,C_ATIVO = :ATIVO       ');
    dmDados.ibAtualizacao.SQL.Add('WHERE I_COD_CLI = :COD_CLI                  ');
    dmDados.ibAtualizacao.ParamByName('COD_CLI').asinteger := strtoint(edCodigo.text);
    dmDados.ibAtualizacao.ParamByName('NOM_CLI').asstring  := edNome.text;
    dmDados.ibAtualizacao.ParamByName('CPF_CNPJ').asstring := edCPF_CNPJ.Text;
    if cbCexo.ItemIndex = 0 then
      dmDados.ibAtualizacao.ParamByName('SEXO').value      := 'M'
    else
      dmDados.ibAtualizacao.ParamByName('SEXO').value      := 'F';
    dmDados.ibAtualizacao.ParamByName('NASC').value        := strtodate(edDatNasc.text);
    dmDados.ibAtualizacao.ParamByName('OBS').value         := edObs.Text;
    if cbAtivo.Checked then
      dmDados.ibAtualizacao.ParamByName('ATIVO').value     := 'Y'
    else
      dmDados.ibAtualizacao.ParamByName('ATIVO').value     := 'N';
    dmDados.ibAtualizacao.execSQL;
    dmDados.ibTransDados.Commit;
  except
    ON E :EXCEPTION DO
    begin
      prErro := true;
      wmsg := 'Ocorreu o erro ' + e.Message;
      if dmDados.ibTransDados.InTransaction then
         dmDados.ibTransDados.Rollback;
      application.MessageBox(pchar(wmsg),'Ateno',0);
    end;
  end;
end;

procedure TfrmCadClientes.btnSalvarClick(Sender: TObject);
var
  wErro:boolean;
begin
  if trim(edNome.Text) = '' then
  begin
    application.MessageBox('Informe o nome do cliente','Ateno',0);
    exit;
  end;
  if cbTipo.ItemIndex = -1 then
  begin
    application.MessageBox('Informe o tipo de cliente.','Ateno',0);
    exit;
  end;
  if edDatNasc.Text = '  /  /    ' then
  begin
    application.MessageBox('Informe a data de nascimento.','Ateno',0);
    exit;
  end;
  if cbCexo.ItemIndex = -1 then
  begin
    application.MessageBox('Informe o sexo do cliente.','Ateno',0);
    exit;
  end;
  wErro:= false;
  if edCodigo.Text = '' then
    AtualizaDadoNovo(wErro)
  else
    AtualizaDadoAltera(wErro);
  if not wErro then
    enabledBotao(TRUE,FALSE,FALSE,FALSE,TRUE);
end;

procedure TfrmCadClientes.btnCancelarClick(Sender: TObject);
begin
  LimpaCampos;
  enabledBotao(TRUE,FALSE,FALSE,FALSE,TRUE);
  PageControl1.Enabled := false;
end;

procedure TfrmCadClientes.btnApagarClick(Sender: TObject);
var
  wErro:boolean;
begin
  ExcluirArquivo(wErro);
  if not wErro then
  begin
    enabledBotao(TRUE,FALSE,FALSE,FALSE,TRUE);  
    PageControl1.Enabled := false;
    LimpaCampos;
  end;  
end;

procedure TfrmCadClientes.ExcluirArquivo(prErro: boolean);
var
  wmsg:string;
begin
  if edCodigo.Text <> '' then
  begin
    if MessageDlg('Deseja excluir este cliente?',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      try
        if not dmDados.ibTransDados.InTransaction then
          dmDados.ibTransDados.StartTransaction;
        dmDados.ibAtualizacao.Close;
        dmDados.ibAtualizacao.SQL.Add('DELETE FROM TCLIENTES      ');
        dmDados.ibAtualizacao.SQL.Add('WHERE I_COD_CLI = :COD_CLI ');
        dmDados.ibAtualizacao.ParamByName('COD_CLI').asinteger := strtoint(edCodigo.text);
        if not dmDados.ibAtualizacao.Prepared then
          dmDados.ibAtualizacao.Prepare;
        dmDados.ibAtualizacao.execSQL;
        dmDados.ibTransDados.Commit;
      except
        ON E :EXCEPTION DO
        begin
          prErro := true;
          wmsg := 'Ocorreu o erro ' + e.Message;
          if dmDados.ibTransDados.InTransaction then
            dmDados.ibTransDados.Rollback;
          application.MessageBox(pchar(wmsg),'Ateno',0);
        end;
      end;
    end;  
  end
end;

procedure TfrmCadClientes.enabledBotao(prNovo, prSalva, prCancela, prApaga,
  prProcura: boolean);
begin
  btnNovo.Enabled     := prNovo;
  btnSalvar.Enabled   := prSalva;
  btnCancelar.Enabled := prCancela;
  btnApagar.Enabled   := prApaga;
  btnProcura.enabled  := prProcura;
end;

end.
