unit umovContasAReceber;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Mask, ComCtrls, Buttons, ExtCtrls, uLocalizaReg,
  Grids, DBGrids;

type
  TfrmMov = class(TForm)
    Panel4: TPanel;
    btnNovo: TBitBtn;
    btnSalvar: TBitBtn;
    btnCancelar: TBitBtn;
    btnApagar: TBitBtn;
    Panel1: TPanel;
    btnFechar: TBitBtn;
    btnProcura: TBitBtn;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label7: TLabel;
    edCodigo: TEdit;
    edObs: TEdit;
    edLookProcCli: TEditSearchFixoFox;
    edDtMov: TMaskEdit;
    Label9: TLabel;
    edVlr: TEdit;
    Label10: TLabel;
    Label3: TLabel;
    edDtPgto: TMaskEdit;
    ELookMov: TLookFox;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnFecharClick(Sender: TObject);
    procedure btnNovoClick(Sender: TObject);
    procedure btnProcuraClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnApagarClick(Sender: TObject);
    procedure btnSalvarClick(Sender: TObject);
    procedure btnCancelarClick(Sender: TObject);
    procedure edLookProcCliBeforeBuscaReg(Sender: TObject;
      var pMontar: Boolean);
    procedure edLookProcCliCadastra(Sender: TObject; var pMontar: Boolean);
    procedure edLookProcCliAlterar(Sender: TObject; var pMontar: Boolean);
  private
    { Private declarations }
    gNovo:boolean;
    procedure LimpaCampos;
    procedure AtualizaDados;
    procedure montaSqlCliente;
    procedure ExcluirArquivo(VAR prErro:boolean);
    procedure AtualizaDadoNovo(VAR prErro:boolean);
    procedure AtualizaDadoAltera(VAR prErro:boolean);
    procedure enabledBotao(prNovo,prSalva,prCancela,prApaga,prProcura: boolean);
  public
    { Public declarations }
  end;

var
  frmMov: TfrmMov;

implementation

uses uCollectionFox,UDMDADOS, DB, ucadCliente;

{$R *.dfm}

procedure TfrmMov.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := Cafree;
  frmMov := nil;
end;

procedure TfrmMov.btnFecharClick(Sender: TObject);
begin
  close;
end;

procedure TfrmMov.LimpaCampos;
var
  wind:Smallint;
begin
  for wind := 0 to componentcount - 1 do
  begin
    if components[wind] is TEdit then
      (components[wind] as TEdit).Text := ''
    else
    if components[wind] is TComboBox then
      (components[wind] as TComboBox).Text := ''
    else
    if components[wind] is TMaskEdit then
      (components[wind] as TMaskEdit).Text := '';
  end;
  edLookProcCli.Crear;
  gNovo := false;
end;

procedure TfrmMov.btnNovoClick(Sender: TObject);
begin
  PageControl1.Enabled := true;
  LimpaCampos;
  gNovo := true;
  enabledBotao(FALSE,TRUE,TRUE,FALSE,FALSE);
end;

procedure TfrmMov.btnProcuraClick(Sender: TObject);
begin
  ELookMov.Execute;
  if ELookMov.gAlterou then
  begin
    edCodigo.Text := inttostr(ELookMov.FieldByName('I_COD_MOV').AsInteger);
    edDtMov.Text  := ELookMov.FieldByName('d_dat_mov').AsString;
    edDtPgto.Text := ELookMov.FieldByName('d_dat_pag').AsString;
    edLookProcCli.ParamByName('ATIVO').AsString := 'Y';
    edLookProcCli.TextoBusca := ELookMov.FieldByName('I_Cod_Cli').AsString;
    edLookProcCli.Atualiza;
    edVlr.Text    := ELookMov.FieldByName('n_vlr_mov').AsString;
    edObs.Text    := ELookMov.FieldByName('obs').AsString;
    PageControl1.Enabled := true;
    enabledBotao(FALSE,TRUE,TRUE,TRUE,FALSE);    
  end;
  gNovo := false;
end;

procedure TfrmMov.AtualizaDados;
begin
  try
    if not dmDados.ibTransDados.InTransaction then
       dmDados.ibTransDados.StartTransaction;
    dmDados.ibAtualizacao.Close;
    dmDados.ibAtualizacao.SQL.Add('INSERT INTO TMOVIMENTACAO(    ');
    dmDados.ibAtualizacao.SQL.Add('I_COD_MOV,I_COD_CLI,D_DAT_MOV,');
    dmDados.ibAtualizacao.SQL.Add('D_DAT_PAG,N_VLR_MOV,C_OBS)    ');
    dmDados.ibAtualizacao.SQL.Add('VALUES (:COD_MOV,:COD_CLI,:DAT_MOV,');
    dmDados.ibAtualizacao.SQL.Add(':DAT_PAG,:VLR_MOV,:OBS)            ');
    dmDados.ibAtualizacao.ParamByName('COD_MOV').asinteger := 4;
    dmDados.ibAtualizacao.ParamByName('COD_CLI').asinteger := edLookProcCli.ParamByName('I_COD_MOV').AsInteger;
    dmDados.ibAtualizacao.ParamByName('DAT_MOV').value     := strtodate(edDtMov.Text);
    if edDtPgto.Text <> '' then
      dmDados.ibAtualizacao.ParamByName('DAT_PAG').value     := strtodate(edDtPgto.Text);
    dmDados.ibAtualizacao.ParamByName('VLR_MOV').value     := strtofloat(edVlr.text);
    dmDados.ibAtualizacao.ParamByName('OBS').value         := edObs.text;
    if not dmDados.ibAtualizacao.Prepared then
      dmDados.ibAtualizacao.Prepare;
    dmDados.ibAtualizacao.execSQL;
    dmDados.ibTransDados.Commit;
  except
    if dmDados.ibTransDados.InTransaction then
       dmDados.ibTransDados.Rollback;
  end;
end;

procedure TfrmMov.FormCreate(Sender: TObject);
begin
  gNovo := false;
end;

procedure TfrmMov.btnApagarClick(Sender: TObject);
var
  wErro:boolean;
begin
  ExcluirArquivo(wErro);
  if not wErro then
  begin
    enabledBotao(TRUE,FALSE,FALSE,FALSE,TRUE);  
    PageControl1.Enabled := false;
    LimpaCampos;
  end;  
end;

procedure TfrmMov.ExcluirArquivo(var prErro: boolean);
var
  wmsg:string;
begin
  if(edCodigo.Text <> '')and (edLookProcCli.FieldByName('I_COD_CLI').AsInteger > 0)then
  begin
    if MessageDlg('Deseja excluir este registro?',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      try
        if not dmDados.ibTransDados.InTransaction then
          dmDados.ibTransDados.StartTransaction;
        dmDados.ibAtualizacao.Close;
        dmDados.ibAtualizacao.SQL.Add('DELETE FROM TMOVIMENTACAO  ');
        dmDados.ibAtualizacao.SQL.Add('WHERE I_COD_MOV :CODIGO    ');
        dmDados.ibAtualizacao.SQL.Add('AND   I_COD_CLI = :COD_CLI ');
        dmDados.ibAtualizacao.ParamByName('CODIGO').asinteger  := strtoint(edCodigo.text);
        dmDados.ibAtualizacao.ParamByName('COD_CLI').asinteger := edLookProcCli.FieldByName('I_COD_CLI').AsInteger;
        if not dmDados.ibAtualizacao.Prepared then
          dmDados.ibAtualizacao.Prepare;
        dmDados.ibAtualizacao.execSQL;
        dmDados.ibTransDados.Commit;
      except
        ON E :EXCEPTION DO
        begin
          prErro := true;
          wmsg := 'Ocorreu o erro ' + e.Message;
          if dmDados.ibTransDados.InTransaction then
            dmDados.ibTransDados.Rollback;
          application.MessageBox(pchar(wmsg),'Ateno',0);
        end;
      end;
    end;  
  end
end;

procedure TfrmMov.enabledBotao(prNovo,prSalva,prCancela,prApaga,prProcura: boolean);
begin
  btnNovo.Enabled     := prNovo;
  btnSalvar.Enabled   := prSalva;
  btnCancelar.Enabled := prCancela;
  btnApagar.Enabled   := prApaga;
  btnProcura.enabled  := prProcura;
end;

procedure TfrmMov.btnSalvarClick(Sender: TObject);
var
  wErro:boolean;
begin
  wErro:= false;
  if gNovo then
    AtualizaDadoNovo(wErro)
  else
    AtualizaDadoAltera(wErro);
  if not wErro then
    enabledBotao(TRUE,FALSE,FALSE,FALSE,TRUE);
end;

procedure TfrmMov.btnCancelarClick(Sender: TObject);
begin
  enabledBotao(TRUE,FALSE,FALSE,FALSE,TRUE);
end;

procedure TfrmMov.AtualizaDadoAltera(var prErro: boolean);
function TiraPonto(prValor:string):string;
var
  wAux:string;
  wpos:smallint;
begin
  wAux := prValor;
  wpos := pos('.',wAux);
  if wpos > 0 then
  begin
    delete(waux,wpos,1);
    result := waux;
  end;
end;
var
  wmsg :string;
  wVlr:string;
begin
  try
    if not dmDados.ibTransDados.InTransaction then
       dmDados.ibTransDados.StartTransaction;
    dmDados.ibAtualizacao.Close;
    dmDados.ibAtualizacao.SQL.Add('UPDATE TMOVIMENTACAO SET                  ');
    dmDados.ibAtualizacao.SQL.Add('D_DAT_MOV = :DAT_MOV,D_DAT_PAG = :DAT_PAG,');
    dmDados.ibAtualizacao.SQL.Add('N_VLR_MOV = :VLR_MOV,C_OBS = :OBS          ');
    dmDados.ibAtualizacao.SQL.Add('WHERE I_COD_MOV = :COD_MOV                ');
    dmDados.ibAtualizacao.SQL.Add('AND   I_COD_CLI = :COD_CLI                ');
    dmDados.ibAtualizacao.ParamByName('COD_MOV').asinteger := strtoint(edCodigo.text);
    dmDados.ibAtualizacao.ParamByName('COD_CLI').asinteger := strtoint(edCodigo.text);
    if edDtMov.text <> '  /  /    ' then    
      dmDados.ibAtualizacao.ParamByName('DAT_MOV').value     := strtodate(edDtMov.text)
    else
      dmDados.ibAtualizacao.ParamByName('DAT_MOV').value     := null;
    if edDtPgto.text <> '  /  /    ' then
      dmDados.ibAtualizacao.ParamByName('DAT_PAG').value     := strtodate(edDtPgto.text)
    else
      dmDados.ibAtualizacao.ParamByName('DAT_PAG').value     := null;
    wVlr := TiraPonto(edVlr.Text);  
    dmDados.ibAtualizacao.ParamByName('VLR_MOV').Value     := strtofloat(wVlr);
    dmDados.ibAtualizacao.ParamByName('OBS').AsString      := edObs.Text;
    if not dmDados.ibAtualizacao.Prepared then
      dmDados.ibAtualizacao.Prepare;
    dmDados.ibAtualizacao.execSQL;
    dmDados.ibTransDados.Commit;
  except
    ON E :EXCEPTION DO
    begin
      prErro := true;
      wmsg := 'Ocorreu o erro ' + e.Message;
      if dmDados.ibTransDados.InTransaction then
         dmDados.ibTransDados.Rollback;
      application.MessageBox(pchar(wmsg),'Ateno',0);
    end;
  end;
end;

procedure TfrmMov.AtualizaDadoNovo(VAR prErro: boolean);
function BuscaCodigo:integer;
begin
  dmDados.qrBusca2.Close;
  dmDados.qrBusca2.SQL.Clear;
  dmDados.qrBusca2.sql.add('SELECT GEN_ID(Gen_i_cod_Mov, 1) as ID from rdb$database');
  dmDados.qrBusca2.open;
  result := dmDados.qrBusca2.fieldbyname('ID').asinteger;
end;
var
  wmsg:string;
  wcodigo:integer;
begin
  try
    if not dmDados.ibTransDados.InTransaction then
       dmDados.ibTransDados.StartTransaction;
    dmDados.ibAtualizacao.Close;

    if not dmDados.ibTransDados.InTransaction then
       dmDados.ibTransDados.StartTransaction;
    wCodigo := BuscaCodigo;
    dmDados.ibAtualizacao.Close;
    dmDados.ibAtualizacao.SQL.Add('INSERT INTO TMOVIMENTACAO(     ');
    dmDados.ibAtualizacao.SQL.Add('I_COD_MOV,I_COD_CLI,D_DAT_MOV, ');
    dmDados.ibAtualizacao.SQL.Add('D_DAT_PAG,N_VLR_MOV,C_OBS)     ');
    dmDados.ibAtualizacao.SQL.Add('VALUES (:COD_MOV,:COD_CLI,:DAT_MOV, ');
    dmDados.ibAtualizacao.SQL.Add(':DAT_PAG,:VLR_MOV,:OBS)     ');
    dmDados.ibAtualizacao.ParamByName('COD_MOV').asinteger := wCodigo;
    dmDados.ibAtualizacao.ParamByName('COD_CLI').asinteger := edLookProcCli.FieldByName('I_COD_CLI').AsInteger;
    if edDtMov.text <> '  /  /    ' then    
      dmDados.ibAtualizacao.ParamByName('DAT_MOV').value     := strtodate(edDtMov.text)
    else
      dmDados.ibAtualizacao.ParamByName('DAT_MOV').value     := null;
    if edDtPgto.text <> '  /  /    ' then
      dmDados.ibAtualizacao.ParamByName('DAT_PAG').value     := strtodate(edDtPgto.text)
    else
      dmDados.ibAtualizacao.ParamByName('DAT_PAG').value     := null;
    dmDados.ibAtualizacao.ParamByName('VLR_MOV').Value     := strtofloat(edVlr.Text);
    dmDados.ibAtualizacao.ParamByName('OBS').AsString      := edObs.Text;
    if not dmDados.ibAtualizacao.Prepared then
      dmDados.ibAtualizacao.Prepare;
    dmDados.ibAtualizacao.execSQL;
    dmDados.ibTransDados.Commit;
    if not dmDados.ibAtualizacao.Prepared then
      dmDados.ibAtualizacao.Prepare;
    dmDados.ibAtualizacao.execSQL;
    dmDados.ibTransDados.Commit;
    edCodigo.text := inttostr(wCodigo);
  except
    ON E :EXCEPTION DO
    begin
      prErro := true;
      wmsg := 'Ocorreu o erro ' + e.Message;
      if dmDados.ibTransDados.InTransaction then
         dmDados.ibTransDados.Rollback;
      application.MessageBox(pchar(wmsg),'Ateno',0);
    end;
  end;
end;

procedure TfrmMov.edLookProcCliBeforeBuscaReg(Sender: TObject;
  var pMontar: Boolean);
begin
  edLookProcCli.ParamByName('ATIVO').AsString := 'Y';
end;

procedure TfrmMov.edLookProcCliCadastra(Sender: TObject;
  var pMontar: Boolean);
begin
  Application.CreateForm(TfrmCadClientes,frmCadClientes);
  frmCadClientes.btnNovo.Enabled := false;
  frmCadClientes.btnSalvar.Enabled := true;
  frmCadClientes.btnCancelar.Enabled := true;
  frmCadClientes.btnProcura.Enabled  := false;
  frmCadClientes.PageControl1.Enabled := true;  
  frmCadClientes.ShowModal;
end;

procedure TfrmMov.edLookProcCliAlterar(Sender: TObject;
  var pMontar: Boolean);
begin
  Application.CreateForm(TfrmCadClientes,frmCadClientes);  
  frmCadClientes.btnNovo.Enabled := false;
  frmCadClientes.btnSalvar.Enabled := true;
  frmCadClientes.btnCancelar.Enabled := true;
  frmCadClientes.btnProcura.Enabled  := false;
  frmCadClientes.PageControl1.Enabled := true;
  montaSqlCliente;  
  frmCadClientes.ShowModal;
end;

procedure TfrmMov.montaSqlCliente;
begin
  frmCadClientes.edCodigo.text := inttostr(edLookProcCli.FieldByName('I_COD_CLI').AsInteger);
  if edLookProcCli.FieldByName('c_tip_cli').AsString = 'F' then
  begin
    frmCadClientes.cbTipo.ItemIndex := 0;
    frmCadClientes.edCPF_CNPJ.EditMask := '999.999.999/99;0;_'
  end
  else
  begin
    frmCadClientes.cbTipo.ItemIndex := 1;
    frmCadClientes.edCPF_CNPJ.EditMask := '99.999.999/9999-99;0;_'
  end;
  frmCadClientes.edCPF_CNPJ.text := edLookProcCli.FieldByName('C_CPF_CNPJ').AsString;
  frmCadClientes.edNome.text := edLookProcCli.FieldByName('C_NOM_CLI').AsString;
  frmCadClientes.edDatNasc.text := edLookProcCli.FieldByName('D_NASC').AsString;
  if edLookProcCli.FieldByName('c_sexo').AsString = 'M' then
    frmCadClientes.cbCexo.ItemIndex := 0
  else
    frmCadClientes.cbCexo.ItemIndex := 1;
  frmCadClientes.edObs.text := edLookProcCli.FieldByName('OBS').AsString;
  frmCadClientes.cbAtivo.Checked := edLookProcCli.FieldByName('c_ativo').AsString = 'Y';
  PageControl1.Enabled := true;
end;
{  edCodigo
  cbTipo
  edCPF_CNPJ
  edNome
  cbCexo
  edObs}
//end;

end.
